"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  try {
    var err = new Error();
    var callerfile = void 0;
    var currentfile = void 0;

    Error.prepareStackTrace = function (err, stack) {
      return stack;
    };

    currentfile = err.stack.shift().getFileName();

    while (err.stack.length) {
      callerfile = err.stack.shift().getFileName();

      if (currentfile !== callerfile) return callerfile;
    }
  } catch (err) {}

  return undefined;
};