'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

/**
 *
 * @name isString
 * @param target {string}
 * @returns {boolean}
 *
 * @description "return target.length && typeof target !== 'object'" returns undefined if target {number}
 * @copyright Sentiurin Vladimir 2017
 */

exports.default = function (target) {
  if (target.length && (typeof target === 'undefined' ? 'undefined' : _typeof(target)) !== 'object') return true;else return false;
};